<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>

<body>

    <script>
        /* 
            Faça um algoritmo que retorne se um palavra é anagram da outra
        */
        function isAnagram(test, original) {
            let testChars = charCount(test.toLowerCase())
            let origChars = charCount(original.toLowerCase())

            // feio, mas funciona
            for (let [char, value] of testChars.entries()) {
                if (origChars.get(char) != value) {
                    return false
                }
            }
            for (let [char, value] of origChars.entries()) {
                if (testChars.get(char) != value) {
                    return false
                }
            }
            
            return true
        }
        
        function charCount(string) {
            let map = new Map()
            for (let char of string) {
                map.set(char, (map.get(char) + 1) || 1)
            }
            return map
        }

        // Resultados esperados
        console.log(isAnagram("foefet", "toffee"), true) // true
        console.log(isAnagram("Buckethead", "DeathCubeK"), true) // true
        console.log(isAnagram("Twoo", "WooT"), true) // true

        console.log(isAnagram("dumble", "bumble"), false) // false
        console.log(isAnagram("ound", "round"), false) // false
        console.log(isAnagram("apple", "pale"), false) // false

    </script>
</body>

</html>